struct callinfo
{
	long start;
	long dur;
};

long ltime()
{
	timeval t; gettimeofday(&t,NULL);
	return t.tv_sec;
}

int fixlist(std::list<callinfo>& l)
{
	std::list<callinfo>::iterator i; i=l.begin();
	while (i!=l.end())
	{
		const long now=ltime();
		const long fin=i->start+i->dur;
		if (now>fin) i=l.erase(i);
		else i++;
	}
	return l.size();
}

std::string getCallFile(const std::string& c, const std::string& cid, const int
d)
{
        std::ostringstream out;
        out << "Channel: "<<c<<"\n";
        out << "Callerid: "<<cid<<"\n";
        out << "Application: Wait\n";
        out << "Data: "<<d<<"\n";
        return out.str();
}


std::string createCall(const::std::string& c, 
			std::string cid,
			const int duration,
			std::list<callinfo>& cinfo,const int gid)
{
	std::cout <<"*NEW* ["<<gid<<"] D="<<duration<<" CID="<<cid<<"\n";
	callinfo cc;	cc.start=ltime(); cc.dur=duration;
	cinfo.push_back(cc);
	return getCallFile(c,cid,duration);
}


std::string command(const std::string& fname)
{
	std::ostringstream c;
	c<<"chown asterisk:asterisk "<<fname<<" && mv "<<fname<<" /var/spool/asterisk/outgoing/.";
	return c.str();
}

std::string get_fname(const int gid)
{
        std::ostringstream f; f<<gid<<".call";
        return f.str();
}


int SystemCall(const std::string script)
{
        int sys_ret=0;
        sys_ret = system(script.c_str());
        return sys_ret;
}

