#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <sstream>
#include <sys/time.h>
#include <list>
#include <unistd.h>


//aux.h only to be included in main.cpp
#include "aux.h"

const std::string c1="Local/703@from-internal/n";


int main(int argn, char** argc)
{
	std::string chanout=c1;
	const int callmin=10;	//minimum calls
	const int callmax=callmin;
	const int dmin=90;	//minimum duration
	const int dmax=dmin;
	int iofset=0;
	int iend=600;
	// 
	std::vector<std::string> cids;
	cids.push_back("9999999");
	const int ncid=cids.size();
	if (ncid<1) return 0;
	std::cout <<"# Using channel "<<chanout <<"\n";
	std::cout <<"# Linux time now="<<ltime()<<"\n";
	std::cout <<"# Calls between "<<callmin<<" and "<<callmax<<"\n";
	std::cout <<"# Call duration between "<<dmin<<" and "<<dmax<<"\n";
	std::cout <<"# Starting offset "<<iofset<<" seconds\n";
	std::cout <<"# Ending   offset "<<iend  <<" seconds\n";
	//
	const int timestart=ltime()+iofset;
	const int timeend=timestart+iend;
	if (iofset>0)
	{
		while(ltime()<timestart)
		{
			sleep(10);
			std::cout <<"***** "<<timestart-ltime()<<" seconds till dialer starts!\n";
			std::cout.flush();
		}
	}
	std::list<callinfo> cinfo;
	//
        const int icalls=callmin;
	long inext=ltime()+30;
	std::cout <<"***** Max calls set to "<<icalls<<"\n";
	int gid=0;
	while(iend<0 ||ltime()<timeend)
	{
		const int ileft=timeend-ltime();
		if (ltime()>inext) 
		{
			inext+=30;
		}
		sleep(1);
		const int callsnow=fixlist(cinfo);
		std::cout <<callsnow<<"/"<<icalls;
		if (ileft>0) std::cout<<" - "<<ileft <<" seconds left";
		std::cout<<"\n";
		if (callsnow<icalls) 
		{
			std::string fname=get_fname(gid++);
			std::string cfile = createCall(chanout,cids[0],dmin,cinfo,gid);
			//Create Call File
			std::ofstream out(fname.c_str(),std::ios::out); out<<cfile<<"\n"; out.close();
			//move and chown file
			SystemCall( command(fname));
		}
		std::cout.flush();
	}
		
}
